<template>
  <div>
    <v-progress-circular v-if="isLoading" indeterminate color="purple" />
    <v-container fluid class="ma-0 pa-0" v-if="!isLoading">
      <v-row>
        <v-col cols="12" xs="12" sm="12" md="4" lg="4" xl="4">
          <div class="px-3" v-if="complete">
            {{ dimension.name }}
          </div>
        </v-col>
        <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8" v-if="desktop">
          <div class="px-3" v-if="complete">
            Recomendaciones por componentes de {{ dimension.name }}
          </div>
        </v-col>
      </v-row>

      <v-row class="ma-0 pa-0" v-if="complete">
        <v-col cols="12" xs="12" sm="12" md="4" lg="4" xl="4">
          <v-card height="100%" class="pa-3">
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-6 ma-0 pa-0 title-card-text"
            >
              Índice
            </v-row>
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-6 ma-0 pa-0 tway-violet--text"
            >
              <v-progress-circular
                :rotate="-90"
                :size="180"
                :width="22"
                :value="dimension.idx * 10"
                color="#16C62E"
              >
                <span class="roboto pertentage-text"
                  >{{ dimension.idx * 10 }}%</span
                >
              </v-progress-circular>
            </v-row>
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="
                mb-6
                ma-0
                pa-0
                tway-violet--text
                font-weight-bold
                title-card-text
              "
            >
              {{ level }}
            </v-row>
          </v-card>
        </v-col>
        <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
          <v-card
            height="100%"
            class="pa-0 recommendations-card"
            color="#fafafa"
          >
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-2 ma-0 pa-0 tway-violet--text"
            >
              <v-tabs
                v-model="tab"
                background-color="tway-violet"
                dark
                class="dimension-tabs"
              >
                <v-tab
                  v-for="subdimension in subdimensions"
                  :key="subdimension.id"
                  @click="getSubDimensionId(subdimension.id)"
                  style="text-transform: initial"
                  class="tab-text px-10"
                >
                  {{ subdimension.name }}
                </v-tab>
              </v-tabs>
              <v-tabs-items style="width: 100% !important" v-model="tab">
                <v-tab-item
                  v-for="subdimension in subdimensions"
                  :key="subdimension.id"
                >
                  <v-card class="tab-dashboard-item pa-5" elevation="0">
                    <v-card-text class="my-0 py-0 px-6">
                      <v-row
                        class="roboto mb-0"
                        style="
                          white-space: pre-line;
                          word-wrap: break-word;
                          line-height: 24px;
                          color: #333333;
                        "
                      >
                        {{
                          recommendationsSelected(
                            subdimension.name,
                            subdimension.idx,
                            subdimension.value
                          )
                        }}
                      </v-row>
                      <v-row
                        v-if="
                          subdimension.categories &&
                          subdimension.categories.length > 0
                        "
                        class="mt-1"
                      >
                        <v-col class="categories-title ml-0 pl-0 mb-1">
                          Recomendamos integrar estos servicios para acelerar la
                          transformación de tu empresa
                        </v-col>
                      </v-row>

                      <v-row
                        width="100%"
                        justify="start"
                        align="center"
                        class="mb-0 mt-0"
                        v-for="category in subdimension.categories"
                        :key="category"
                      >
                        <v-col class="ma-0 pa-0" cols="1">
                          <v-icon color="#16C62E"> mdi-arrow-right </v-icon>
                        </v-col>
                        <v-col
                          :class="desktop ? 'ml-n7' : 'ml-n1'"
                          class="ma-0 text-left roboto"
                          cols="11"
                          v-if="category"
                          :style="
                            desktop ? 'line-height: 4px' : 'line-height: 12px'
                          "
                        >
                          {{ category }}
                        </v-col>
                      </v-row>
                    </v-card-text>
                  </v-card>
                </v-tab-item>
              </v-tabs-items>
            </v-row>
            <v-row
              width="100%"
              justify="center"
              align="center"
              class="mb-3 ma-0 pa-0 tway-violet--text"
              style="background-color: #fafafa"
            >
              <v-btn
                v-if="subscription.plan.name != 'BUSINESS'"
                rounded
                color="tway-violet"
                class="white--text roboto"
                :to="{ name: 'plans' }"
              >
                VER PLANES
              </v-btn>

              <v-btn
                v-if="subscription.plan.name == 'BUSINESS'"
                rounded
                color="tway-violet"
                class="white--text roboto"
                @click="Projects()"
              >
                CREAR PROYECTOS
              </v-btn>
            </v-row>
          </v-card>
        </v-col>
      </v-row>

      <v-container v-if="complete" fluid>
        <v-card class="pa-6" :height="desktop ? '150px' : '100%'">
          <v-row justify="space-between">
            <v-col cols="12" xs="12" sm="12" md="2" lg="2" xl="2">
              <div class="mt-n4">Hoja de Ruta</div>
              <div>{{ dimension.name }}</div>
            </v-col>
            <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
              <timeline :value="this.dimension.idx" />
            </v-col>
            <v-col cols="12" xs="12" sm="12" md="2" lg="2" xl="2">
              <v-row justify="center" class="align-start">
                <v-img
                  :src="require('@/assets/img/dimension-img.svg')"
                  class="rounded"
                  max-width="55%"
                />
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-container>
      <div class="px-3" v-if="complete">Desafíos Estratégicos</div>
      <v-row class="ma-0 pa-0" v-if="complete">
        <v-col
          cols="12"
          xs="12"
          sm="12"
          md="4"
          lg="4"
          xl="4"
          v-show="dimension.id != i.id"
          v-for="(i, index) in dti.dimensions"
          :key="index"
        >
          <v-card class="pa-5" height="100%">
            <div class="center-vertical-card">
              <div>
                <div class="tway-violet--text title-card-text">
                  {{ i.name }}
                </div>
                <bars :values="i.subdimensions" />
              </div>

              <span
                class="py-3 roboto subtitle-1"
                style="white-space: pre-line; word-wrap: break-word"
              >
                {{ levelSelected(i.name, i.idx) }}</span
              >
              <div class="card-vertical-button py-3">
                <v-btn
                  large
                  rounded
                  color="tway-violet"
                  class="white--text roboto"
                  @click="
                    () => {
                      (dimensionId = i.id), getCurrentUser();
                    }
                  "
                >
                  VER {{ i.name }}
                </v-btn>
              </div>
            </div>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import currentUserService from "@/services/currentUserService";
import subscriptionService from "@/services/subscriptionService";
import dtService from "@/services/dtService";
import LevelsJSON from "@/utils/Levels.json";
import RecommendationsJSON from "@/utils/Recomendaciones.json";
import BarsItems from "@/components/dashboard/BarsItems";
import Timeline from "@/components/dashboard/Timeline";
import { mapActions, mapGetters } from "vuex";

export default {
  name: "DashboardDimension",

  components: {
    timeline: Timeline,
    bars: BarsItems,
  },

  data: () => ({
    isLoading: true,
    indexDimension: 0,
    complete: false,
    facilitadores: false,
    modelo: false,
    mentalidad: false,
    orquestacion: false,
    dimensionId: "",
    idx: 0,
    levels: [],
    recommendations: [],
    questions: [],
    dimension: {
      id: "",
      name: "",
      idx: 1,
    },
    subdimensions: [
      {
        id: "",
        idx: 1,
        name: "",
      },
    ],
    percentage: {
      value: 0,
      name: "Global",
      index: true,
    },
    tab: null,
    subdi: "",
    subscription: {
      plan: {
        name: "",
      },
    },
  }),
  created: function () {
    this.dimensionId = this.$route.params.id;
    this.getCurrentUser();
    this.getLevels();
    this.getRecommendations();
    this.getSubscription();
  },

  methods: {
    ...mapActions("UserStore", ["SET_PERCENTAGE"]),
    getLevels() {
      this.levels = LevelsJSON;
    },
    getRecommendations() {
      this.recommendations = RecommendationsJSON;
    },
    getSubDimensionId(id) {
      this.subdi = id;
    },
    levelSelected: function (name, idx) {
      let indexLevel = this.levels.findIndex((level) => level.name === name);

      if (name == "Modelo de Negocio") {
        idx = this.toFixed((idx * 100) / 28, 1);
      }
      if (name == "Mentalidad") {
        idx = this.toFixed((idx * 100) / 29, 1);
      }
      if (name == "Orquestación") {
        idx = this.toFixed((idx * 100) / 21, 1);
      }
      if (name == "Facilitadores") {
        idx = this.toFixed((idx * 100) / 22, 1);
      }

      if (idx * 10 <= 40) {
        return this.levels[indexLevel].description[0].texto;
      } else if (idx * 10 > 40 && idx * 10 <= 60) {
        return this.levels[indexLevel].description[1].texto;
      } else if (idx * 10 > 60 && idx * 10 <= 80) {
        return this.levels[indexLevel].description[2].texto;
      } else if (idx * 10 > 80) {
        return this.levels[indexLevel].description[3].texto;
      } else {
        return "";
      }
    },
    recommendationsSelected: function (name, idx, value) {
      idx = this.toFixed((idx * 100) / (value * 100), 1);

      let indexrecom = this.recommendations[
        this.indexDimension
      ].subdimensions.findIndex((recom) => recom.name === name);
      if (idx * 10 <= 40) {
        return this.recommendations[this.indexDimension].subdimensions[
          indexrecom
        ].recommendations[0].texto;
      } else if (idx * 10 > 40 && idx * 10 <= 60) {
        return this.recommendations[this.indexDimension].subdimensions[
          indexrecom
        ].recommendations[1].texto;
      } else if (idx * 10 > 60 && idx * 10 <= 80) {
        return this.recommendations[this.indexDimension].subdimensions[
          indexrecom
        ].recommendations[2].texto;
      } else if (idx * 10 > 80) {
        return this.recommendations[this.indexDimension].subdimensions[
          indexrecom
        ].recommendations[3].texto;
      } else {
        return "";
      }
    },
    getCurrentUser() {
      currentUserService
        .currentUserData()
        .then((userData) => {
          this.user = userData;
          dtService
            .getSurveyComplete("a123", this.user.id)
            .then((questions) => {
              this.questions = questions;
              this.SET_PERCENTAGE(
                Math.floor((questions.answered / questions.total) * 100)
              );
              if (this.getPercentage != 100) {
                //this.$router.replace({ name: 'home'});
                this.complete = false;
                this.isLoading = true;
              } else {
                this.complete = true;
                this.getDti(this.user.id, questions.surveyId);
                let container = document.getElementById("main-scroll");
                container.scrollTo({
                  top: 0,
                  left: 0,
                  behavior: "smooth",
                });
              }
            })
            .catch((err) => {
              this.$log.error(err);
              this.isLoading = true;
            });
        })
        .catch((err) => this.$log.error(err));
    },
    toFixed(num, fixed) {
      var re = new RegExp("^-?\\d+(?:\\.\\d{0," + (fixed || -1) + "})?");
      return num.toString().match(re)[0];
    },
    getDti(userId, surveyId) {
      dtService
        .getDti(userId, surveyId)
        .then((dti) => {
          this.dti = dti;
          let indexDimension = this.dti.dimensions.findIndex(
            (e) => e.id == this.dimensionId
          );
          this.indexDimension = indexDimension;
          this.subdimensions =
            this.dti.dimensions[this.indexDimension].subdimensions;

          this.dimension = this.dti.dimensions[this.indexDimension];
          this.idx = this.dti.dimensions[this.indexDimension].idx;
          if (
            this.dti.dimensions[this.indexDimension].name == "Modelo de Negocio"
          ) {
            this.dimension.idx = this.toFixed(
              (this.dti.dimensions[this.indexDimension].idx * 100) / 28,
              1
            );
          }
          if (this.dti.dimensions[this.indexDimension].name == "Mentalidad") {
            this.dimension.idx = this.toFixed(
              (this.dti.dimensions[this.indexDimension].idx * 100) / 29,
              1
            );
          }
          if (this.dti.dimensions[this.indexDimension].name == "Orquestación") {
            this.dimension.idx = this.toFixed(
              (this.dti.dimensions[this.indexDimension].idx * 100) / 21,
              1
            );
          }
          if (
            this.dti.dimensions[this.indexDimension].name == "Facilitadores"
          ) {
            this.dimension.idx = this.toFixed(
              (this.dti.dimensions[this.indexDimension].idx * 100) / 22,
              1
            );
          }
          this.isLoading = false;
        })
        .catch((err) => {
          this.$log.error(err);
        });
    },
    getSubscription: function () {
      subscriptionService
        .getCurrentUserSubscription()
        .then((subscription) => (this.subscription = subscription))
        .catch((err) => this.$log.error("Unexpected error: ", err))
        .then(() => (this.isLoading = false));
    },
    Projects() {
      let dimensionid = this.dimension.id;
      let sub = this.subdi ? this.subdi : this.subdimensions[0].id;
      this.$router.push({
        name: "project-foundation",
        query: { dimension: dimensionid, subdimension: sub },
      });
    },
  },

  computed: {
    ...mapGetters("UserStore", ["getPercentage"]),
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
    level: function () {
      if (this.dimension.idx * 10 <= 40) {
        return "Nivel Basico";
      } else if (
        this.dimension.idx * 10 > 40 &&
        this.dimension.idx * 10 <= 60
      ) {
        return "Nivel Inicial";
      } else if (
        this.dimension.idx * 10 > 60 &&
        this.dimension.idx * 10 <= 80
      ) {
        return "Nivel Estrategico";
      } else if (this.dimension.idx * 10 > 80) {
        return "Nivel Competitivo";
      } else {
        return "";
      }
    },
  },
};
</script>
<style scoped lang="scss">
.center-vertical-card {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100% !important;
  .card-vertical-button {
    width: 100%;
    display: flex;
    justify-content: center;
  }
}
.dimension-title {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 18px;
  line-height: 27px;
}

.small-btn-text-1 {
  font-size: 10px;
  color: #7319d5;
}

.small-btn-text-2 {
  font-size: 10px;
  color: #999999;
}

.center-text {
  text-align: center !important;
}

.title-idx-text {
  font-size: 23px;
  width: 100%;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.title-idx-small {
  font-size: 14px;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.title-idx-subtitle {
  font-size: 25px;
  line-height: 30px;
  font-weight: 700;
  text-align: start;
  color: #7319d5;
}

.item-title {
  font-size: 12px;
  line-height: 14px;
  width: 100%;
  font-weight: 400;
  text-align: start;
  cursor: pointer;
}

.item-title:hover,
.item-title:focus {
  color: rgba(#000, 0.6);
}

.item-score {
  font-size: 30px;
  width: 100%;
  line-height: 14px;
  font-weight: 400;
  color: #333333;
  text-align: start;
}

.item-score-danger {
  font-size: 30px;
  width: 100%;
  color: #b71c1c;
  line-height: 14px;
  font-weight: 400;
  text-align: start;
}

.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}

.title-card-text {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 22px;
  line-height: 30px;
}

.pertentage-text {
  color: #4a148c;
  font-size: 36px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.pertentage-text-danger {
  color: #b71c1c;
  font-size: 50px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.full-height {
  height: 100%;
}

.border-bottom {
  border-bottom: 1px solid #dedede;
}

.worse-title {
  color: #7319d5;
  text-transform: lowercase;
}

.worse-text {
  font-size: 16px;
}
.tab-dashboard-item {
  background: #fafafa;
  /*height: 200px;*/
  /*height: 100%;*/
  height: 235px;
  overflow-y: scroll;
  overflow-x: scroll;
}
.tab-text {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 18px;
  line-height: 27px;
  /* identical to box height, or 150% */

  display: flex;
  align-items: center;
}

.dimension-tabs {
  border-radius: 2px 2px 0 0;
}

.categories-title {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  color: #333333;
}
.category-item {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  color: #333333;
}

.recommendations-card ::-webkit-scrollbar {
  -webkit-appearance: none;
  width: 7px;
  background-color: #fafafa;
}

.recommendations-card ::-webkit-scrollbar-thumb {
  border-radius: 4px;
  background-color: rgba(0, 0, 0, 0.5);
  box-shadow: 0 0 1px rgba(255, 255, 255, 0.5);
}
</style>
